/*
	AudioObjects - AudioObject.h
	(c) 2002-2003 edot studios
	all rights reserved
	
	Author: Lieven Dekeyser <lieven@edot-studios.com>
	
	Version History:
	
		2003-06-18 : added support for changing the stream formats
		2003-06-09 : changed to use the AudioUnit v2 RenderCallback
		2002-01-18 : first version
*/

#import <Foundation/Foundation.h>
#import <AudioUnit/AudioUnit.h>

@interface AudioObject : NSObject {
	OSStatus status;
}

- (AudioUnit)inputUnit;
- (AudioUnit)outputUnit;

- (OSStatus)status;

- (void)connectTo:(AudioObject*)audioObject;
- (void)connectInput:(UInt32)inputNumber to:(AudioObject*)audioObject;
- (void)connectInput:(UInt32)inputNumber toOutput:(UInt32)outputNumber of:(AudioObject*)audioObject;

- (void)connectToRenderCallback:(AURenderCallback)inputProc withRefCon:(void*)refCon;
- (void)connectInput:(UInt32)inputNumber toRenderCallback:(AURenderCallback)inputProc withRefCon:(void*)refCon;

- (void)disconnectInput:(UInt32)inputNumber;

- (void)setStreamFormat:(AudioStreamBasicDescription)format forInput:(UInt32)element;
- (void)setStreamFormat:(AudioStreamBasicDescription)format forOutput:(UInt32)element;

@end

AudioStreamBasicDescription DefaultStereoFormat(BOOL interleaved);
AudioStreamBasicDescription DefaultMonoFormat();
